//
//     File Name: FTCOMTST.PRG
//       Project: ft interfacing
//   Description: test program for ft com(30402) interface
//      Language: Clipper 5.2e
//        Linker: Blinker 4
//        Author: Rene Nooteboom
//  Date created: 27-08-2005
//  Date updated: 28-08-2005
//     Exec File: ftcomtst.exe
//     Copyright: (c) 2005 by Noot Systems Amsterdam
//
#include "inkey.ch"
#include "generic.ch"
#include "noot.ch"
#include "ft.ch"
//
STATIC nComPort := 1
//
FUNCTION main()
 LOCAL nSelectedMotor:=M1,nKeyPressed:=0,i
 Initialize()
 DO WHILE !(lastkey() == K_ESC)
  @ 3,60 SAY nSelectedMotor PICTURE "9"
  FOR i := E1 TO E8
   @ i+2,5 SAY LTOC(FtCSensor(nComPort,i))
  NEXT
  @ 12,5 SAY FtCAD(nComPort,EX) PICTURE "99999999"
  @ 13,5 SAY FtCAD(nComPort,EY) PICTURE "99999999"
  DO CASE
   CASE nKeyPressed == asc("1")
    nSelectedMotor := M1
   CASE nKeyPressed == asc("2")
    nSelectedMotor := M2
   CASE nKeyPressed == asc("3")
    nSelectedMotor := M3
   CASE nKeyPressed == asc("4")
    nSelectedMotor := M4
   CASE nKeyPressed == asc("R") .OR. nKeyPressed == asc("r")
    FtCMotor(nComPort,nSelectedMotor,MCW)
    @ nSelectedMotor+3,44 SAY "MCW "
   CASE nKeyPressed == asc("L") .OR. nKeyPressed == asc("l")
    FtCMotor(nComPort,nSelectedMotor,MCCW)
    @ nSelectedMotor+3,44 SAY "MCCW"
   CASE nKeyPressed == asc("O") .OR. nKeyPressed == asc("o")
    FtCMotor(nComPort,nSelectedMotor,MOFF)
    @ nSelectedMotor+3,44 SAY "MOFF"
   OTHERWISE
  ENDCASE
  UpdateLoops()
  nKeyPressed := inkey()
 ENDDO
 CloseAppl()
RETURN NIL
//
PROCEDURE Initialize()
 MY_BEGIN
 BOXGET nComPort PROMPT "COM#:" PICTURE "9" VALID IS_BETW(nComPort,1,4) ;
  DOUBLE
 CLS
 @ 1,15 SAY "Fischer Techniek COM (30402) Interface diagnose"
 @ 3,1 SAY "E1"
 @ 4,1 SAY "E2"
 @ 5,1 SAY "E3"
 @ 6,1 SAY "E4"
 @ 7,1 SAY "E5"
 @ 8,1 SAY "E6"
 @ 9,1 SAY "E7"
 @ 10,1 SAY "E8"
 @ 3,40 SAY "Selected motor:"
 @ 4,40 SAY "M1  MOFF"
 @ 5,40 SAY "M2  MOFF"
 @ 6,40 SAY "M3  MOFF"
 @ 7,40 SAY "M4  MOFF"
 @ 8,40 SAY "Use keys : 1-4,R,L and O"
 @ 12,1 SAY "EX"
 @ 13,1 SAY "EY"
 @ 15,1 SAY "COM-"
 @ 22,1 SAY "Number of loops:"
 nComPort := FtCInit(nComPort)
 IF nComPort < 1
  CloseAppl()
 ELSE
  @ 15,4 SAY str(nComPort,1) + "[IO=" + FtCHexIO(nComPort) + "h]"
 ENDIF
RETURN
//
PROCEDURE CloseAppl()
 FtCClose(nComPort)
 MY_EINDE
RETURN
//
PROCEDURE UpdateLoops()
 STATIC nCount := 0
 @ 22,22 SAY ++nCount
RETURN
//
// end ftcomtst.prg
//
