**************************************************************************
* module    : GENERIC.CH
* funktie   : general header file
* taal      : CA-Clipper 5.2
* auteur    : Rene Nooteboom
* datum     : created 11-02-1992
*             updated 19-08-2005
**************************************************************************
#stdout generic.ch-Version 5.24-aug2005
**************************************************************************
#ifndef K_UP
 #include "inkey.ch"
#endif
#ifndef FS_RELATIVE
 #include "fileio.ch"
#endif
**************************************************************************
* ENVIRONMENT
**************************************************************************
#xcommand SET DATE [TO] DUTCH => SET DATE ITALIAN
#xcommand DEF_ENVIRONMENT => SET DELETED ON ; SET EXACT OFF ;
 ; SET SOFTSEEK OFF ; SET SCOREBOARD OFF ; SET DATE TO DUTCH ;
 ; SET CENTURY ON ; SET ESCAPE ON ; SET DELIMITERS OFF ; SET WRAP ON
#xcommand DEF_EINDE => CLOSE DATABASES ; RELEASE ALL ; SET CURSOR ON ;
 ; QUIT
**************************************************************************
* GENERAL
**************************************************************************
#define ALARMTOON tone(300,1)
*
*  Convert logical to character
*
#define LTOC(l) if(l,"T","F")
*
* Convert character to logical
*
#define CTOL(c) if(c $ "TtYyJj",.T.,.F.)
*
* Implementing a REPEAT UNTIL Loop as a UDC
*
#xcommand REPEAT => WHILE .T.
#xcommand UNTIL <exp> => IF (<exp>); EXIT; END; END
*
#xcommand DEFAULT <p> TO <v> [,<p2> TO <v2>] => ;
 <p> := if(<p> == NIL,<v>,<p>) [; <p2> := if(<p2> == NIL,<v2>,<p2>)]
*
#xcommand UPDATE <v1> IF <exp> TO <v2>  => IF <exp> ; <v1> := <v2> ; END
**************************************************************************
* FILE IO
**************************************************************************
#define EOLINE chr(13)+chr(10)
#define CR chr(13)
#define LF chr(10)
#define CRLF CR+LF
#define EOFILE chr(26)
#define FORMFEED chr(12)
#define SOFTCR chr(141)
*
#xtranslate FTELLPOS(<nhandle>) => fseek(<nhandle>,0,FS_RELATIVE)
#xtranslate FFILETOP(<nhandle>) => fseek(<nhandle>,0,FS_SET)
#xtranslate FFILEBOTTOM(<nhandle>) => fseek(<nhandle>,0,FS_END)
*
* netwerk ,sharing
*
#xcommand REFRESH RECORD => GOTO recno()
#xcommand FLUSH RECORD => GOTO recno()
*
#xcommand UNLOCK <a> [, <b> ] => ;
 iif(upper( <(a)> ) == "ALL",dbunlockall(),<a> -> (dbunlock())) ;
 [; <b> -> (dbunlock())]
*
* temporarily to fix a bug in Clipper 5.2c,see 52ci.txt
*
#xtranslate rlock() => dbrlock(recno())
#xtranslate dbrlock() => dbrlock(recno())
**************************************************************************
* KEYCODES
**************************************************************************
#ifndef K_SPACE
 #define K_SPACE 32
#endif
#define K_SPATIEBALK K_SPACE
#define K_PLUS       43
#define K_MINUS      45
*
#define ESCAPEKEY (lastkey()==K_ESC)
#define NOTESCAPEKEY (!ESCAPEKEY)
**************************************************************************
* LOGICAL
**************************************************************************
#ifndef TRUE
 #define TRUE .T.
#endif
#ifndef FALSE
 #define FALSE .F.
#endif
#define YES .T.
#define NO .F.
**************************************************************************
* ascii tekens , some based on codepage 437
**************************************************************************
#ifndef UPARROW
 #define UPARROW chr(24)
 #define DOWNARROW chr(25)
 #define LEFTARROW chr(27)
 #define RIGHTARROW chr(26)
#endif
#define DIAMANT chr(4)
#define CYFERS "0123456789"
#define HEXNUMBERS "0123456789ABCDEF"
#define HEARTS chr(3)
#define CBLOCK chr(254)
#define SMILE chr(1)
#define ASCIINULL chr(0)
#define BIGBLOCK chr(219)
#define WORTELTEKEN chr(251)
#define ALPHABET "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define NONPCLETTERS "FIOQY"
**************************************************************************
* PRINTER
**************************************************************************
#define CESCAPE chr(27)
#define CCONDENSED chr(15)
**************************************************************************
* TBROWSE ,some based on using code page 437
**************************************************************************
*
* small standard ascii
*
#define TBHEADSEP  "-"
#define TBCOLSEP   chr(124)
#define TBFOOTSEP  "="
*
* wide standard ascii
*
#define TBHEADSEP1 "---"
#define TBCOLSEP1  " "+chr(124)+ " "
#define TBFOOTSEP1 "==="
*
* wide single lines
*
#define TBHEADSEP2 chr(196)+chr(194)+chr(196)
#define TBCOLSEP2  " "+chr(179)+" "
#define TBFOOTSEP2 chr(196)+chr(193)+chr(196)
*
* wide double lines
*
#define TBHEADSEP3 chr(205)+chr(203)+chr(205)
#define TBCOLSEP3  " "+chr(186)+" "
#define TBFOOTSEP3 chr(205)+chr(202)+chr(205)
*
* wide blocks
*
#define TBHEADSEP4 chr(220)+chr(220)+chr(220)
#define TBCOLSEP4  " "+chr(219)+" "
#define TBFOOTSEP4 chr(223)+chr(223)+chr(223)
*
* small double/single
*
#define TBHEADSEP5 chr(205)
#define TBCOLSEP5  chr(179)
#define TBFOOTSEP5 chr(205)
*
* small single
*
#define TBHEADSEP6 chr(196)
#define TBCOLSEP6  chr(179)
#define TBFOOTSEP6 chr(196)
*
* small blocks
*
#define TBHEADSEP7 chr(220)
#define TBCOLSEP7  chr(219)
#define TBFOOTSEP7 chr(223)
*
* wide double/single
*
#define TBHEADSEP8 chr(205)+chr(209)+chr(205)
#define TBCOLSEP8  " "+chr(179)+" "
#define TBFOOTSEP8 chr(205)+chr(207)+chr(205)
*
* spaces
*
#define TBHEADSEP9 space(1)
#define TBCOLSEP9  space(1)
#define TBFOOTSEP9 space(1)
*
* default separators
*
#define DEF_HSEP TBHEADSEP8
#define DEF_CSEP TBCOLSEP8
#define DEF_FSEP TBFOOTSEP8
*
#define TBROWSEST_KEYS {{K_PGUP,{|o|o:PageUp()}},{K_PGDN,{|o|o:PageDown()}}, ;
 {K_UP,{|o|o:Up()}},{K_DOWN,{|o|o:Down()}},{K_LEFT,{|o|o:Left()}}, ;
 {K_RIGHT,{|o|o:Right()}},{K_CTRL_PGUP,{|o|o:GoTop()}}, ;
 {K_CTRL_PGDN,{|o|o:GoBottom()}},{K_HOME,{|o|o:Home()}}, ;
 {K_END,{|o|o:End()}},{K_CTRL_HOME,{|o|o:PanHome()}}, ;
 {K_CTRL_END,{|o|o:PanEnd()}},{K_CTRL_LEFT,{|o|o:PanLeft()}}, ;
 {K_CTRL_RIGHT,{|o|o:PanRight()}}}
****************************************************************************
* centered message always to screen
*
#xtranslate SCRNCENTER(<nrow>,<cmsg>[,<ccolor>]) => setpos(<nrow>,int(( ;
 maxcol()+1 - len(<cmsg>))/2)) ; dispout(<cmsg>[,<ccolor>])
*****************************************************************************
#define MEM_PACK() memory(-1)  // voer een memory compaction uit
#define MEM_EMS() memory(4)  // EMS-geheugen beschikbaar voor clipper
#define MEM_SVOS() memory(3) // geheugen voor complexe datatypes
#define MEM_FREE() memory(0)
#define MEM_RUN() memory(2) // geheugen vrij voor run commands
**************************************************************************
* DATA MANIPULATION
**************************************************************************
#xtranslate STRINGNUM(<nval>) => ltrim(str(<nval>))
#define MAXXYZ(x,y,z) => max(max(x,y),z)
**************************************************************************
* DATES
**************************************************************************
#xtranslate DATETEXT() => STRINGNUM(day(date())) + " " + cmonth(date()) + ;
 " " + str(year(date()),4)
#define EMPTYDATE ctod("")
**************************************************************************
#define MAANDEN_ {"JANUARI","FEBRUARI","MAART","APRIL","MEI","JUNI", ;
 "JULI","AUGUSTUS","SEPTEMBER","OKTOBER","NOVEMBER","DECEMBER"}
#define DAYSINMONTH_ {31,28,31,30,31,30,31,31,30,31,30,31}
**************************************************************************
* GET SYSTEM
**************************************************************************
#xcommand READ START <nget> => readmodal(getlist,<nget>) ; getlist:={}
**************************************************************************
* GENERAL I/O
**************************************************************************
* centered message
*
#xtranslate DEVCENTER(<nrow>,<cmsg>[,<ccolor>]) => devpos(<nrow>,int(( ;
 maxcol()+1 - len(<cmsg>))/2)) ; devout(<cmsg>[,<ccolor>])
**************************************************************************
* ARRAY MANIPULATION
**************************************************************************
* return the first empty elementnr in a 1-dimensional array
*
#xtranslate AEMPTY(<foo>) => ascan(<foo>,{|x| empty(x) })
*
* return the last filled elementnr in a one-dimensional array
*
#xtranslate AFULL(<foo>) => eval({ |x| if(x==0,len(<foo>),x-1) }, ;
 ascan(<foo>,{ |y| y == NIL} ) )
*
* return the first uninitialized elementnr in a 1-dimensional array
*
#xtranslate ANIL(<foo>) => ascan(<foo>, {|y| y == NIL} )
*
* cast a variable of any type to an array
*
#xtranslate ARRAYIFY(<foo>) => <foo> := if(valtype(<foo>) != ;
 "A", {<foo>},<foo> )
*
* lookup a key in one array return parallel element in a second
* array if found
*
#xtranslate CASE_OF(<foo>,<a1>,<a2>) => eval({|x| if(x>0,<a2>\[ x \], ;
 "") }, ascan(<a1>,<foo>) )
*
* delete last element of array and decrement size by one
*
#define ASHRINK(arr) asize(arr,len(arr)-1)
#define AGROW(arr) asize(arr,len(arr)+1)
*
* soft search ignoring case
*
#define ASCANISOFT(arr,cvalue) ascan(arr,{|el|upper(el)>=upper(cvalue)})
*
* soft search respecting case
*
#define ASCANSOFT(arr,cvalue) ascan(arr,{|el|el>=cvalue})
*
* exact search ignoring case
*
#define ASCANNOCASE(arr,cvalue) ascan(arr,{|el|upper(el)==upper(cvalue)})
*
* exact search respecting case
*
#define ASCANEXACT(arr,cvalue) ascan(arr,{|el|el==cvalue})
*
#define ARRAY_SKIPPER(i,a) {|n,nSavei|nSavei := i,i := if (n > 0, ;
  Min(Len(a), i + n),Max(1, i + n)),i - nSavei}
***************************************************************************
* DATA TYPES
***************************************************************************
* return a boolean indicating whether a variable is of the indicated type
*
#xtranslate IS_ARRAY(<foo>) => (valtype(<foo>) == "A")
#xtranslate IS_BLOCK(<foo>) => (valtype(<foo>) == "B")
#xtranslate IS_CHAR(<foo>) => (valtype(<foo>) == "C")
#xtranslate IS_DATA(<foo>) => (<foo> \>= 32 .AND. <foo> \<= 253 )
#xtranslate IS_DATE(<foo>) => (valtype(<foo>) == "D")
#xtranslate IS_DEF(<foo>) => !(type(<foo>) $ "UE" )
#xtranslate IS_DIGIT(<foo>) => isdigit(<foo>)
#xtranslate IS_INT(<foo>) => (<foo> == int(<foo>) )
#xtranslate IS_ASCII(<xval>) => (if(valtype(<xval>)=="N", ;
 <xval> \> 0 .AND. <xval> \< 128,asc(<xval>) \>0 .AND. ;
 asc(<xval>) \< 128))
#xtranslate IS_PRINTABLE(<xval>) => (if(valtype(<xval>)=="N", ;
 <xval> \>=32 .AND. <xval> \<= 126,asc(<xval>) \>=32 .AND. ;
 asc(<xval>) \<= 126))
#xtranslate IS_CONTROLCHAR(<xval>) => (if(valtype(<xval>)=="N", ;
 (<xval> \>=0 .AND. <xval> \<= 31) .OR. <xval> == 127, ;
 (asc(<xval>) \>=0 .AND. asc(<xval>) \<= 31) .OR. asc(<xval>)==127))
#define IS_LINKED(routine) !(type(routine)=="U")
#xtranslate IS_LOGIC(<foo>) => (valtype(<foo>) == "L")
#xtranslate IS_MEMO(<foo>) => (valtype(<foo>) == "M")
#xtranslate IS_NUM(<foo>) => (valtype(<foo>) == "N")
#xtranslate IS_OBJECT(<foo>) => (valtype(<foo>) == "O")
#xtranslate IS_NIL(<foo>) => (<foo> == NIL)
#xtranslate IS_ELEMENT(<array_>,<xvalue>) =>  ;
 (ascan(<array_>,{|el|el==<xvalue>}) > 0)
#xtranslate IS_ESCAPE() => set(_SET_ESCAPE)
#xtranslate IS_DEVSCR() => (set(_SET_DEVICE)=="SCREEN")
#xtranslate IS_DEVPRT() => (set(_SET_DEVICE)=="PRINTER")
#xtranslate IS_CURSOR() => empty(setcursor())
**********************************************************************
* DATA VALUE TESTS
**********************************************************************
* tests for odd and even number
*
#xtranslate IS_EVEN(<foo>) => ( (<foo> % 2)  == 0 )
#xtranslate IS_ODD(<foo>) => ( (<foo> % 2) != 0 )
*
* return a boolean indicating whether a string,numeric or date
* is within a range
*
#xtranslate IS_BETW(<foo>,<lo>,<hi>) => (<foo> \>= <lo> .AND. ;
 <foo> \<= <hi> )
**********************************************************************
* DATA MANIPULATION
**********************************************************************
* return a string,date or numeric forced between a minimum and maximum
*
#xtranslate MINIMAX(<var>,<lo>,<hi>) => min(<hi>,max(<var>,<lo>))
**********************************************************************
* CODE BLOCKS
**********************************************************************
* execute code at runtime if it is a string macrocompile it if it
* is a codeblock evaluate it
*
#xtranslate EXECUTE(<foo>) => (if(valtype(<foo>)=="B",eval(<foo>), ;
 &(<foo>) ) )
*
* return a code block from a string expression by macro compilation
*
#xtranslate MACROBLOCK(<foo>) => &( "{||" + <foo> - "}" )
*
* Translation Directive to Create Get/Set block
*
#xtranslate GSB(<x>) => {|x1| iif(x1 == NIL, <x>, <x> := x1 }
*
* Compiler Macro to Convert Character String into Code Block
*
#define COMPILE(c) &("{||" + c + "}")
**************************************************************************
* FILES , DISKS
**************************************************************************
*
* return a boolean whether a dbf exists
*
#xtranslate DBF_EXIST(<foo>) => file(<foo> - if("." $ <foo>,"",".DBF"))
*
* default a filename extension to ".DBF"
*
#xtranslate DBF_NAME(<foo>) => <foo> - if("." $ <foo>,"",".DBF")
*
* return a boolean indicating whether a char.string is a fieldname
* in the current work area
*
#xtranslate IS_FIELD(<foo>) => (fieldpos(<foo>) > 0)
*
* return a boolean whether an alias is open
*
#xtranslate IS_OPEN(<foo>) => (select(<foo>) > 0)
*
* return true if char.string is not name of a field
*
#xtranslate IS_VIRTUAL(<foo>) => (fieldpos(<foo>) == 0)
*
* return the filename from a pathname
*
#xtranslate FILENAME(<foo>) => substr(<foo>,max(1+rat(":",<foo>), ;
 1+rat("\",<foo>) ) )
*
* create a full path from a directory string and a filename
*
#xtranslate FULLPATH(<dir>,<file>) => ltrim(<dir>) - if(empty(<dir>), ;
 "",if(right(<dir>,1) $ "\:","","\"))  + if("\" $ <dir>,"","\") + ;
 alltrim(<file>)
*
* return a boolean indicating whether a characterstring is a directory
* name
*
#xtranslate IS_DIR(<foo>) => file(if("" == <foo>,"", if(right(<foo>,1) ;
 $ ":\",<foo>,<foo>+"\") + "NUL" ) )
*
* return the name of a file shorn of its extension
*
#xtranslate ROOTNAME(<foo>) => if("." $ <foo>,left(<foo>,rat(".",<foo>) ;
 -1),<foo>)
*
* extract the extension from a filespec
*
#xtranslate GIVEEXT(<foo>) => (if("." $ <foo>,rtrim(substr(<foo>,  ;
 rat(".",<foo>)+1)),""))
*
* evaluate a code block for each file in the directory
* example call : DIREVAL("*.bak","HS",{|f|ferase(f[F_NAME])})
*
#xtranslate DIREVAL(<cmask>,<cattributes>,<baction>) => ;
 aeval(directory(<cmask>,<cattributes>),<baction>)
***************************************************************************
* STRINGS
***************************************************************************
* determine if a string contains * or ?
*
#xtranslate IS_WILDCARD(<foo>) => ("*" $ <foo> .OR. "?" $ <foo>)
*
* increment asciivalue of last character of a string
*
#define INCLAST(c) substr(c,1,len(c)-1)+chr(asc(substr(c,len(c)))+1)
***************************************************************************
* DATES
***************************************************************************
#xtranslate DATEFORMAT() => set(_SET_DATEFORMAT)
***************************************************************************
* VIDEO
***************************************************************************
#define ATTR_CONV(FORE,BACK) ( (BACK) * 16 + (FORE) )
#define TM80X25X16CGA    3     // video modes bios
#define TM80X25X2MDA     7
#define GM320X200X4CGA   4
#define GM640X200X2CGA   6
#define GM320X200X16EGA  13  // 0Dh
#define GM640X200X16EGA  14  // 0Eh
#define GM640X350X2EGA   15  // 0Fh
#define GM640X350X16EGA  16  // 10h
#define GM640X480X2VGA   17  // 11h
#define GM640X480X16VGA  18  // 12h
#define GM320X200X256VGA 19  // 13h
#define NBLACK    0
#define NBLUE     1
#define NGREEN    2
#define NCYAN     3
#define NRED      4
#define NMAGENTA  5
#define NBROWN    6
#define NWHITE    7
#define NGRAY     8
#define NBRIGHTBLUE    9
#define NBRIGHTGREEN   10
#define NBRIGHTCYAN    11
#define NBRIGHTRED     12
#define NBRIGHTMAGENTA 13
#define NYELLOW        14
#define NBRIGHTWHITE   15
***************************************************************************
* end generic.ch
**************************************************************************
